package studio.meaningless.esa;

import net.fabricmc.api.ModInitializer;
import net.fabricmc.fabric.api.item.v1.FabricItemSettings;
import net.fabricmc.fabric.api.itemgroup.v1.ItemGroupEvents;
import net.fabricmc.fabric.api.object.builder.v1.entity.FabricDefaultAttributeRegistry;
import net.minecraft.item.Item;
import net.minecraft.item.ItemGroups;
import net.minecraft.item.Items;
import net.minecraft.item.SpawnEggItem;
import net.minecraft.registry.Registries;
import net.minecraft.registry.Registry;
import net.minecraft.util.Identifier;
import studio.meaningless.esa.entity.ModEntities;
import studio.meaningless.esa.entity.custom.EsaGolemEntity;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class Esa implements ModInitializer {
	// For printing logs
	public static final Logger LOGGER = LoggerFactory.getLogger("esa");
	// Custom Items
	public static final Item ESA_CRYSTAL = Registry.register(Registries.ITEM, new Identifier("esa", "esa_crystal"),
			new Item(new FabricItemSettings()));
	// Spawn Eggs
	public static final Item ESA_GOLEM_SPAWN_EGG = Registry.register(Registries.ITEM,
			new Identifier("esa", "esa_golem_spawn_egg"),
			new SpawnEggItem(ModEntities.ESA_GOLEM, 0x19BA5D, 0x26158, new FabricItemSettings()));

	@Override
	public void onInitialize() {
		LOGGER.info("Esa Initializing");
		// Modify Item Groups
		// Add items to Ingredients
		ItemGroupEvents.modifyEntriesEvent(ItemGroups.INGREDIENTS).register(content -> {
			content.addAfter(Items.AMETHYST_SHARD, ESA_CRYSTAL);
		});
		// Add Items To Spawn Eggs
		ItemGroupEvents.modifyEntriesEvent(ItemGroups.SPAWN_EGGS).register(content -> {
			content.add(ESA_GOLEM_SPAWN_EGG);
		});
		// Register Entities
		FabricDefaultAttributeRegistry.register(ModEntities.ESA_GOLEM, EsaGolemEntity.setAttributes());
	}
}