package studio.meaningless.esa.entity.custom;

import net.minecraft.entity.EntityType;
import net.minecraft.entity.ai.goal.ActiveTargetGoal;
import net.minecraft.entity.ai.goal.MeleeAttackGoal;
import net.minecraft.entity.ai.goal.WanderAroundFarGoal;
import net.minecraft.entity.attribute.DefaultAttributeContainer;
import net.minecraft.entity.attribute.EntityAttributes;
import net.minecraft.entity.mob.HostileEntity;
import net.minecraft.entity.mob.MobEntity;
import net.minecraft.entity.passive.AnimalEntity;
import net.minecraft.entity.passive.PassiveEntity;
// import net.minecraft.entity.mob.ZombieEntity;
import net.minecraft.entity.player.PlayerEntity;
import net.minecraft.server.world.ServerWorld;
import net.minecraft.world.World;
import software.bernie.geckolib.animatable.GeoEntity;
import software.bernie.geckolib.core.animatable.instance.AnimatableInstanceCache;
import software.bernie.geckolib.core.animation.AnimatableManager;
import software.bernie.geckolib.core.animation.Animation;
import software.bernie.geckolib.core.animation.AnimationController;
import software.bernie.geckolib.core.animation.AnimationState;
import software.bernie.geckolib.core.animation.RawAnimation;
import software.bernie.geckolib.core.object.PlayState;
import software.bernie.geckolib.util.GeckoLibUtil;

// public class EsaGolemEntity extends HostileEntity implements GeoEntity {
    public class EsaGolemEntity extends AnimalEntity implements GeoEntity {
// public class EsaGolemEntity extends ZombieEntity implements GeoEntity {
    private AnimatableInstanceCache cache = GeckoLibUtil.createInstanceCache(this);

    // Set attributes of the mob
    public static DefaultAttributeContainer.Builder setAttributes() {
        // return HostileEntity.createMobAttributes()
        return AnimalEntity.createMobAttributes()
                .add(EntityAttributes.GENERIC_MAX_HEALTH, 200.0D)
                .add(EntityAttributes.GENERIC_ATTACK_DAMAGE, 10.0f)
                .add(EntityAttributes.GENERIC_ATTACK_SPEED, 140.0f) // cooldown between attacks
                .add(EntityAttributes.GENERIC_MOVEMENT_SPEED, 3f) // default player is 0.1
                // .add(EntityAttributes.GENERIC_MOVEMENT_SPEED, 0.05f) // default player is 0.1
                .add(EntityAttributes.GENERIC_FOLLOW_RANGE, 15.0)
                .add(EntityAttributes.GENERIC_KNOCKBACK_RESISTANCE, 0.8) // 1.0 is 100%, 0 is 0%
                .add(EntityAttributes.GENERIC_ATTACK_KNOCKBACK, 1.5) // ravager is 1.5
                .add(EntityAttributes.GENERIC_ARMOR, 15); // default for iron armor is 15
    }

    // Add goals (for mob ai)
    @Override
    protected void initGoals() {
        this.goalSelector.add(2, new WanderAroundFarGoal(this, 1.0));
        this.goalSelector.add(1, new MeleeAttackGoal(this, 0.5, false));

        this.targetSelector.add(1, new ActiveTargetGoal<PlayerEntity>((MobEntity)this, PlayerEntity.class, true));
    }
public EsaGolemEntity(EntityType<? extends AnimalEntity> entityType, World world) {
    // public EsaGolemEntity(EntityType<? extends ZombieEntity> entityType, World world) {
        super(entityType, world);
    }

    // Geckolib stuff
    @Override
    public AnimatableInstanceCache getAnimatableInstanceCache() {
        return cache;
    }

    @Override
    public void registerControllers(AnimatableManager.ControllerRegistrar controllerRegistrar) {
        controllerRegistrar.add(new AnimationController<>(this, "controller", 0, this::predicate));
    }

    private PlayState predicate(AnimationState tAnimationState) {
        if (tAnimationState.isMoving()) {
            tAnimationState.getController()
                    .setAnimation(RawAnimation.begin().then("animation.esa_golem.walk", Animation.LoopType.LOOP));
            return PlayState.CONTINUE;

        }

        tAnimationState.getController()
                .setAnimation(RawAnimation.begin().then("animation.esa_golem.idle", Animation.LoopType.LOOP));
        return PlayState.CONTINUE;

    }

    @Override
    public PassiveEntity createChild(ServerWorld var1, PassiveEntity var2) {
        // TODO Auto-generated method stub
        throw new UnsupportedOperationException("Unimplemented method 'createChild'");
    }

}
